--# -path=.:../scandinavian:../abstract:../../prelude

concrete BasicSwe of Basic = CategoriesSwe ** open ParadigmsSwe in {

flags startcat=Phr ; lexer=textlit ; unlexer=text ;
  optimize=values ;

lin
  airplane_N = regN "flygplan" neutrum ;
  answer_V2S = mkV2S (regV "svara") "till" ;
  apartment_N = mk2N "lgenhet" "lgenheter" ;
  apple_N = regN "pple" neutrum ;
  art_N = mk2N "konst" "konster" ;
  ask_V2Q = mkV2Q (regV "frga") [] ;
  baby_N = regN "bebis" utrum ;
  bad_ADeg = irregADeg "dlig" "smre" "smst";
  bank_N = mk2N "bank" "banker" ;
  beautiful_ADeg = mk3ADeg "vacker" "vackert" "vackrast" ;
  become_VA = mkVA (mkV "bli" "blir""bli" "blev" "blivit" "bliven") ;
  beer_N = regN "l" neutrum ;
  beg_V2V = mkV2V (mkV "be" "ber""be" "blad" "bett" "bedd") [] "att" ;
  big_ADeg = irregADeg "stor" "strre" "strst";
  bike_N = mk2N "cykel" "cyklar" ;
  bird_N = mk2N "fgel" "fglar" ;
  black_ADeg = mk2ADeg "svart" "svart" ;
  blue_ADeg = mk2ADeg "bl" "bltt";
  boat_N = regN "bt" utrum ;
  book_N = mkN "bok" "boken" "bcker" "bckerna" ;
  boot_N = mk2N "stvel" "stvlar" ;
  boss_N = mk2N "chef" "chefer" ;
  boy_N = regN "pojke" utrum ;
  bread_N = regN "brd" neutrum ;
  break_V2 = dirV2 (partV (mkV "sl" "slr" "sl" "slog" "slagit" "slagen") "snder") ;
  broad_ADeg = mk2ADeg "bred" "brett" ;
  brother_N2 = mkN2 (mascN (mkN "bror" "brodern" "brder" "brderna")) "till" ;
  brown_ADeg = regADeg "brun" ;
  butter_N = regN "smr" neutrum ;
  buy_V2 = dirV2 (mk2V "kpa" "kpte") ;
  camera_N = regN "kamera" utrum ;
  cap_N = regN "mssa" utrum ;
  car_N = regN "bil" utrum ;
  carpet_N = regN "matta" utrum ;
  cat_N = mk2N "katt" "katter" ;
  ceiling_N = regN "tak" neutrum ;
  chair_N = regN "stol" utrum ;
  cheese_N = regN "ost" utrum ;
  child_N = regN "barn" neutrum ;
  church_N = regN "kyrka" utrum ;
  city_N = mk2N "stad" "stder" ;
  clean_ADeg = regADeg "ren" ;
  clever_ADeg = regADeg "klok" ;
  close_V2 = dirV2 (mk2V "stnga" "stngde") ;
  coat_N = regN "rock" utrum ;
  cold_ADeg = regADeg "kall" ;
  come_V = (mkV "komma" "kommer" "kom" "kom" "kommit" "kommen") ;
  computer_N = mk2N "dator" "datorer" ;
  country_N = mkN "land" "landet" "lnder" "lnderna" ;
  cousin_N = mk2N "kusin" "kusinerna" ;
  cow_N = mk2N "ko" "kor" ;
  die_V = (mkV "d" "dr" "d" "dog" "dtt" "ddd") ; ----
  distance_N3 = mkN3 (mk2N "avstnd" "avstnd") "frn" "till" ;
  dirty_ADeg = regADeg "smutsig" ;
  doctor_N = mk2N "lkare" "lkare" ;
  dog_N = regN "hund" utrum ;
  door_N = regN "drr" utrum ;
  drink_V2 = dirV2 (irregV "dricka" "drack" "druckit") ;
  easy_A2V = mkA2V (mk2A "ltt" "ltt") "fr" ;
  eat_V2 = dirV2 (irregV "ta" "t" "tit") ;
  empty_ADeg = mkADeg "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ;
  enemy_N = regN "fiende" neutrum ;
  factory_N = mk2N "fabrik" "fabriker" ;
  father_N2 = mkN2 (mascN (mkN "far" "fadern" "fder" "fderna")) "till" ;
  fear_VS = mkVS (regV "frukta") ;
  find_V2 = dirV2 (irregV "finna" "fann" "funnit") ;
  fish_N = mk2N "fisk" "fiskar" ;
  floor_N = regN "golv" neutrum ;
  forget_V2 = dirV2 (mkV "glmma" "glmmer" "glm" "glmde" "glmt" "glmd") ;
  fridge_N = regN "kylskp" neutrum ;
  friend_N = mkN "vn" "vnnen" "vnner" "vnnerna" ;
  fruit_N = mk2N "frukt" "frukter" ;
  fun_AV = mkAV (regA "rolig") ;
  garden_N = regN "trdgrd" utrum ;
  girl_N = regN "flicka" utrum ;
  glove_N = regN "handske" utrum ;
  gold_N = regN "guld" neutrum ;
  good_ADeg = mkADeg "god" "gott" "goda" "goda" "bttre" "bst" "bsta" ;
  go_V = (mkV "g" "gr" "g" "gick" "gtt" "gngen") ;
  green_ADeg = regADeg "grn" ;
  harbour_N = regN "hamn" utrum;
  hate_V2 = dirV2 (regV "hata") ;
  hat_N = regN "hatt" utrum ;
  have_V2 = dirV2 (mkV "ha" "har" "ha" "hade" "haft" "haft") ; ---- pp
  hear_V2 = dirV2 (mkV "hra" "hr" "hr" "hrde" "hrt" "hrd") ;
  hill_N = regN "kulle" utrum ;
  hope_VS = mkVS (depV (regV "hoppas")) ;
  horse_N = regN "hst" utrum ;
  hot_ADeg = regADeg "het" ;
  house_N = regN "hus" neutrum ;
  important_ADeg = regADeg "viktig" ;
  industry_N = mk2N "industri" "industrier" ; ---- "ien" ??
  iron_N = regN "jrn" neutrum ;
  king_N = mascN (regN "kung" utrum) ;
  know_V2 = dirV2 (mkV "veta" "vet" "vet" "visste" "vetat" "visst") ;
  lake_N = mkN "sj" "sjn" "sjar" "sjarna" ;
  lamp_N = regN "lampa" utrum;
  learn_V2 = dirV2 (mkV "lra" "lr" "lr" "lrde" "lrt" "lrd") ; ---- refl!
  leather_N = mkN "lder" "ldret" "lder" "ldren" ;
  leave_V2 = dirV2 (regV "lmna") ;
  like_V2 = mkV2 (mk2V "tycka" "tyckte") "om" ;
  listen_V2 = mkV2 (regV "lyssna") "p" ;
  live_V = (irregV "leva" "levde" "levt") ; ---- ?
  long_ADeg = irregADeg "lng" "lngre" "lngst" ;
  lose_V2 = dirV2 (regV "frlora") ;
  love_N = regN "krlek" utrum ;
  love_V2 = dirV2 (regV "lska") ;
  man_N = mascN (mkN "man" "mannen" "mn" "mnnen") ;
  married_A2 = mkA2 (mk2A "gift" "gift") "med" ;
  meat_N = regN "ktt" neutrum ;
  milk_N = regN "mjlk" utrum ; ---- -ar?
  moon_N = regN "mne" utrum ;
  mother_N2 = mkN2 (mkN "mor" "modern" "mdrar" "mdrarna") "till" ;
  mountain_N = regN "berg" neutrum ;
  music_N = mk2N "musik" "musiker" ; ---- er ?
  narrow_ADeg = regADeg "smal" ;
  new_ADeg = mkADeg "ny" "nytt" "nya" "nya" "nyare" "nyast" "nyaste" ;
  newspaper_N = regN "tidning" utrum ;

  oil_N = regN "olja" utrum ;
  old_ADeg = mkADeg "gammal" "gammalt" "gamla" "gamla" "ldre" "ldst" "ldsta" ;
  open_V2 = dirV2 (regV "ppna") ;
  paint_V2A = mkV2A (regV "mla") [] ;
  paper_N = mkN "papper" "pappret" "papper" "pappren" ;
  peace_N = regN "fred" utrum ; ---- ar?
  pen_N = regN "penna" utrum ;
  planet_N = mk2N "planet" "planeter" ;
  plastic_N = mk2N "plast" "plaster" ;
  play_V2 = dirV2 (regV "spela") ;
  policeman_N = mk2N "polis" "poliser" ;
  priest_N = mk2N "prst" "prster" ;
  probable_AS = mkAS (regA "sannolik") ;
  queen_N = regN "drottning" utrum ;
  radio_N = regN "radio" utrum ; ----
  rain_V0 = mkV0 (regV "regna") ;
  read_V2 = dirV2 (mk2V "lsa" "lste") ;
  red_ADeg = mk2ADeg "rd" "rtt" ;
  religion_N = mk2N "religion" "religioner" ;
  restaurant_N = mk2N "restaurang" "restauranger" ;
  river_N = mkN "" "n" "ar" "arna" ;
  rock_N = regN "sten" utrum ;
  roof_N = regN "tak" neutrum ;
  rubber_N = mkN "gummi" "gummit" "gummin" "gummina" ;
  run_V = (irregV "springa" "sprang" "sprungit") ;
  say_VS = mkVS (mkV "sga" "sger" "sg" "sade" "sagt" "sagd") ;
  school_N = regN "skola" utrum;
  science_N = mk2N "vetenskap" "vetenskaper" ;
  sea_N = mkN "sj" "sjn" "sjar" "sjarna" ;
  seek_V2 = dirV2 (mk2V "ska" "skte") ;
  see_V2 = dirV2 (mkV "se" "ser" "se" "sg" "sett" "sedd") ;
  sell_V3 = dirV3 (irregV "slja" "slde" "slt") "till" ;
  send_V3 = dirV3 (regV "skicka") "till" ;
  sheep_N = mk2N "fr" "fr" ;
  ship_N = regN "skepp" neutrum ;
  shirt_N = regN "skjorta" utrum ;
  shoe_N = regN "sko" utrum ;
  shop_N = mk2N "affr" "affren" ;
  short_ADeg = regADeg "kort" ;
  silver_N = mkN "silver" "silvret" "silver" "silvren" ;
  sister_N = mk2N "syster" "systrar" ;
  sleep_V = (irregV "sova" "sov" "sovit") ;
  small_ADeg = mkADeg "liten" "litet" "lilla" "sm" "mindre" "minst" "minsta" ;
  snake_N = regN "orm" utrum ;
  sock_N = regN "strumpa" utrum ;
  speak_V2 = dirV2 (regV "tala") ;
  star_N = regN "stjrna" utrum ;
  steel_N = regN "stl" utrum ;
  stone_N = regN "sten" utrum ;
  stove_N = regN "spis" utrum ;
  student_N = mk2N "student" "studenter" ;
  stupid_ADeg = mk3ADeg "dum" "dumt" "dumma" ;
  sun_N = regN "sol" utrum ;
  switch8off_V2 = dirV2 (partV (irregV "stnga" "stngde" "stngt") "av") ;
  switch8on_V2 = dirV2 (partV (irregV "sl" "slog" "slagit") "p") ;
  table_N = regN "bord" neutrum ;
  talk_V3 = mkV3 (regV "prata") "till" "om" ;
  teacher_N = mk2N "lrare" "lrare" ;
  teach_V2 = dirV2 (regV "undervisa") ;
  television_N = mk2N "television" "televisioner" ;
  thick_ADeg = regADeg "tjock" ;
  thin_ADeg = mk2ADeg "tunn" "tunt" ;
  train_N = regN "tg" neutrum ;
  travel_V = mk2V "resa" "reste" ;
  tree_N = regN "trd" neutrum ;
  ----  trousers_N = regN "trousers" ; ---- pl t !
  ugly_ADeg = regADeg "ful" ;
  understand_V2 = dirV2 (mkV "frst" "frstr" "frst" "frstod" "frsttt" "frstdd") ;
  university_N = regN "universitet" neutrum ;
  village_N = mkN "by" "byn" "byar" "byarna" ;
  wait_V2 = mkV2 (regV "vnta") "p" ;
  walk_V = (mkV "g" "gr" "g" "gick" "gtt" "gngen") ;
  warm_ADeg = regADeg "varm" ;
  war_N = regN "krig" neutrum ;
  watch_V2 = mkV2 (regV "titta") "p" ;
  water_N = mkN "vatten" "vattnet" "vatten" "vattnen" ;
  white_ADeg = regADeg "vit" ;
  window_N = mkN "fnster" "fnstret" "fnster" "fnstren" ;
  wine_N = mkN "vin" "vinet" "viner" "vinerna" ; ----
  win_V2 = dirV2 (irregV "vinna" "vann" "vunnit") ;
  woman_N = regN "kvinna" utrum ;
  wonder_VQ = mkVQ (regV "undra") ;
  wood_N = mkN "tr" "tret" "tren" "trena" ; ---- ?
  write_V2 = dirV2 (irregV "skriva" "skrev" "skrivit") ;
  yellow_ADeg = regADeg "gul" ;
  young_ADeg = irregADeg "ung" "yngre" "yngst" ;

  do_V2 = dirV2 (mkV "gra" "gr" "gr" "gjorde" "gjort" "gjord") ;
  now_Adv = mkAdv "nu" ;
  already_Adv = mkAdv "redan" ;
  song_N = mk2N "sng" "snger" ;
  add_V3 = mkV3 (partV (irregV "lgga" "lade" "lagt") "till") [] "till" ;
  number_N = mkN "nummer" "numret" "numren" "numren" ;
  put_V2 = mkV2 (irregV "stta" "satte" "satt") [] ;
  stop_V = regV "stanna" ;
  jump_V = regV "hoppa" ;
  here_Adv = mkAdv "hr" ;
  here7to_Adv = mkAdv "hit" ;
  here7from_Adv = mkAdv ["hrifrn"] ;
  there_Adv = mkAdv "dr" ;
  there7to_Adv = mkAdv "dit" ;
  there7from_Adv = mkAdv ["drifrn"] ;

} ;
